;------------------------------------------------------------------------------
; SHI (Super Hires Interlace 96x200) viewer
; based on Super-Hires-Interlace displayer (C)1994 by Colabor/Vermes
; recoded 1998 by Tomas Pribyl (dundera@volny.cz)
; patched 1999 by Josef Soucek (josef.soucek@ct.cz)
; superCPU fixed by Tomas Pribyl
;
; For more information on the IDE64 project,
; please see http://ide64.come.to
; or mail to: Josef.Soucek@ct.cz
;------------------------------------------------------------------------------
; This viewer can display packed and unpacked SHI pictures 

; Memory mapping
; $4000 - $5f40  bitmap1
; $6000 - $7400  sprites1
; $7400 - $7800  hires colors
; $7800 - $7c00  copy of $7400 - $7800
; $c000 - $df40  bitmap2
; $e000 - $f400  sprites2
; $f400 - $f800  copy of $7400 - $7800
; $f800 - $fc00  copy of $7400 - $7800

;format of SHI file
;$7fff          packing byte
;$8000 - $895f  bitmap 1
;$8960 - $92bf  bitmap 2
;$92c0 - $a6bf  sprites 1
;$a6c0 - $babf  sprites 2
;$bac0 - $bbeb  hires colors
;$bbec - $bbf3  sprites colors
;other bytes are unimportant.

;definice kernalovych vektoru

cint    = $ff81
ioinit  = $ff84
ramtas  = $ff87
restor  = $ff8a
vector  = $ff8d
setmsg  = $ff90
second  = $ff93
tksa    = $ff96
memtop  = $ff99
membot  = $ff9c
scnkey  = $ff9f
settmo  = $ffa2
acptr   = $ffa5
ciout   = $ffa8
untlk   = $ffab
unlsn   = $ffae
listen  = $ffb1
talk    = $ffb4
readst  = $ffb7
setlfs  = $ffba
setnam  = $ffbd
open    = $ffc0
close   = $ffc3
chkin   = $ffc6
chkout  = $ffc9
clrchn  = $ffcc
chrin   = $ffcf
chrout  = $ffd2
load    = $ffd5
save    = $ffd8
settim  = $ffdb
rdtim   = $ffde
stop    = $ffe1
getin   = $ffe4
clall   = $ffe7
udtim   = $ffea
screen  = $ffed
plot    = $fff0
iobase  = $fff3


;Harddrive calls

hddread         =$def4
hddwrite        =$def1

scpu_normal     =$d07a
scpu_turbo      =$d07b

DEBUG=0
;--------------------------------------
                * =  $1000          
                
                .if DEBUG=1                
                lda #$37
                sta $01
                cli
                jmp start_view
                .endif
                
;--------------------------------------

                jmp start_without_name ;tady to startuji rucne
                jmp start_with_name    ;tady je start MANAGERem

;--------------------------------------
; zobrazovaci IRQ rutina
;--------------------------------------

line            .macro num

                inc $d020
                inc $d021
                lda $d012
                sta 'num'

                .endm
;--------------------------------------
; PAL 63 cyklu ; NTSC 64, 65
;--------------------------------------

RASTER          = $1c                  ;$1c $1e

irq_disp        = *                    ;38 to 45 cycles
                lda #<irq_disp_2
                sta $0314
                lda #>irq_disp_2
                sta $0315
                nop           ; waste at least 12 cycles
                nop           ; (up to 64 cycles delay allowed here)
                nop
                nop
                nop
                nop
                inc $d012     ; At this stage, $d012 has already been incremented by one.
                lda #1
                sta $d019     ; acknowledge the first raster interrupt
                cli           ; enable interrupts (the second interrupt can now occur)
                ldy #9
                dey
                bne *-1       ; delay
                nop           ; The second interrupt will occur while executing these
                nop           ; two-cycle instructions.
                nop
                nop
                nop
                                          ;Po vykonani irq2, se to sem navrati
;                jmp $ea31                 ;ea7e
                jmp $ea81

;--------------------------------------
odkazy          

irq_disp_2      = *                     ;38 or 39 cycles

                lda #RASTER
                sta $d012

                lda #<irq_disp
                sta $0314
                lda #>irq_disp
                sta $0315
                
;-----------
                lda     #$32
                jsr     set_y_spt
                
                lda     #$d0    ;$f400/$7400 hires barvy
                sta     $d018
                
                ldx     #218 ;$e0 - 224 wait
i100f           dex     
                bne     i100f
                
                ldx     #$80
                jsr     place1
                
                ldx     #$88
                jsr     place2
                
                lda     #$47
                jsr     set_y_spt
                ldy     #1
                ldx     #$7d
                jsr     wait    ;--------------
                
                lda     #$e0    ;$f800/$7800  
                sta     $d018
                ldx     #$90
                jsr     place1
                lda     #$5c
                jsr     set_y_spt
                ldy     #1
                ldx     #$7d
                jsr     wait    ;--------------
                
                lda     #$d0    ;$f400/$7400
                sta     $d018
                ldx     #$98
                jsr     place2
                lda     #$71
                jsr     set_y_spt
                ldy     #1
                ldx     #$8e    ;8c
                jsr     wait    ;--------------
                
                lda     #$e0    ;$f800/$7800
                sta     $d018
                ldx     #$a0
                jsr     place1
                lda     #$86
                jsr     set_y_spt
                ldy     #1
                ldx     #$77    ;78
                jsr     wait    ;--------------
                nop
                nop
                nop
                
                lda     #$d0    ; $f400/$7400
                sta     $d018
                ldx     #$a8
                jsr     place2
                lda     #$9b
                jsr     set_y_spt
                ldy     #1
                ldx     #$85
                jsr     wait    ;--------------
                
                nop     
                lda     #$e0    ; $f800/$7800
                sta     $d018
                ldx     #$b0
                jsr     place1
                lda     #$b0
                jsr     set_y_spt
                ldy     #1
                ldx     #$82
                jsr     wait    ;--------------
                
                lda     #$d0    ; $f400/$7400
                sta     $d018
                ldx     #$b8
                jsr     place2
                lda     #$c5
                jsr     set_y_spt
                ldy     #1
                ldx     #$7d
                jsr     wait    ;--------------
                
                lda     #$e0    ;$f800/$7800
                sta     $d018
                ldx     #$c0
                jsr     place1
                lda     #$da
                jsr     set_y_spt
                ldy     #1
                ldx     #$88    ;87
                jsr     wait    ;--------------
                
                lda     #$d0    ;$f400/$7400
                sta     $d018
                ldx     #$c8
                jsr     place2
                lda     #$ef
                jsr     set_y_spt
                ldy     #1
                ldx     #$7d
                jsr     wait    ;--------------
                
                lda     #$e0    ; $f800/$7800
                sta     $d018

                lda #1
                sta $d019     ; acknowledge the irq

                ldy     #1
                ldx     #$5f
                jsr     wait    ;--------------
                
                lda     $dd00   ;Switch Video page
                eor     #2
                sta     $dd00
                
                jmp $ea81     ;## pla tay pla tax pla rti
                
;--------------------------------------
wait            dex     
                bne     wait
                dey     
                bne     wait
                rts     

;--------------------------------------
place1          stx     $77f8
                stx     $f7f8
                inx     
                stx     $77f9
                stx     $f7f9
                inx     
                stx     $77fa
                stx     $f7fa
                inx     
                stx     $77fb
                stx     $f7fb
                inx     
                stx     $77fc
                stx     $f7fc
                inx     
                stx     $77fd
                stx     $f7fd
                inx     
                stx     $77fe
                stx     $f7fe
                inx     
                stx     $77ff
                stx     $f7ff
                rts

;--------------------------------------
place2          stx     $7bf8
                stx     $fbf8
                inx     
                stx     $7bf9
                stx     $fbf9
                inx     
                stx     $7bfa
                stx     $fbfa
                inx     
                stx     $7bfb
                stx     $fbfb
                inx     
                stx     $7bfc
                stx     $fbfc
                inx     
                stx     $7bfd
                stx     $fbfd
                inx     
                stx     $7bfe
                stx     $fbfe
                inx     
                stx     $7bff
                stx     $fbff
                rts
     
;--------------------------------------
set_y_spt       sta     $d001
                sta     $d003
                sta     $d005
                sta     $d007
                sta     $d009
                sta     $d00b
                sta     $d00d
                sta     $d00f
                rts     
;End of IRQ
;--------------------------------------

start_without_name = *
                lda #$80
                sta man_sign    ;started from basic
                
                jsr clrchn
                jsr clall
                lda #<product_txt
                ldy #>product_txt
                jsr $ab1e

                lda #<file_txt  ;input filename
                ldy #>file_txt
                jsr $ab1e

                ldy #$00
getfilename     jsr chrin
                cmp #$0d
                beq geted
                sta filename,y
                iny
                jmp getfilename
                
geted           tya
                ldx #<filename
                ldy #>filename
                jmp skip_sign

;-----------------------------------------------------------------------
; START from MANAGER                
start_with_name pha
                tya
                pha
                txa
                pha
                
                lda #$00
                sta man_sign
                lda #$93     ;clrscreen
                jsr chrout
                lda #<product_txt
                ldy #>product_txt
                jsr $ab1e
                
                pla
                tax
                pla
                tay
                pla

;----------------------------------------------------------------------

skip_sign       jsr setnam

                lda $d018
                sta vic_d018
                
                lda $d020
                sta vic_d020
                lda $d021
                sta vic_d021
                
                lda $dd00
                sta cia_dd00
                
                lda $0314
                sta irq_old
                lda $0315
                sta irq_old+1
                
                lda $9d
                sta messages
                
                
                lda #1
                ldx $ba
                ldy #0
                jsr setlfs
                
                jsr open
              ;  bcc open_ok
              ;  
              ;  tax            ;prenes chybu
              ;  jsr $a43a      ;tisk chyby
              ;  
              ;  jsr file_err   ;close file & set error flag
              ;  rts            ;error in system during opening
                
                
open_ok         jsr read_status
                beq file_ok
                bit man_sign
                bpl no_print   ; 00-manager, no print on screen
                
                lda #$0d       ;odradkuje
                jsr chrout
                
                lda #<status_buf
                ldy #>status_buf
                jsr $ab1e
                
no_print        jsr restore_system
                jsr file_err   ;close file & set error flag
                rts            ;error in device during opening


file_ok         ldx #1
                jsr chkin
                
                jsr chrin
                cmp #$ff
                bne invalid   ;file_err
                jsr chrin
                cmp #$7f
                bne invalid   ;file_err ;test pocatecni adresy $7fff
                
                jsr chrin    ;test komprimacniho priznaku
                cmp #$00     ;nekomprimovano
                bne conttest
                jmp load_it  ; LOAD without DECOMPRESS

;-------------------------------------------------------------                
invalid         jsr restore_system
                jsr file_err  ;close file
                lda #<invalid_txt
                ldy #>invalid_txt
                jmp $ab1e

;--------------------------------------------------------------
; UNCOMPRESS LOAD
;                
conttest        cmp #$01     ;komprese #1
                beq unrlc
                
                jsr restore_system
                jsr file_err      ;zavre soubor
                lda #<unknown_txt
                ldy #>unknown_txt ;unknown compression method
                jmp $ab1e

;--------------------filedepacking---
unrlc           lda #<compress_txt
                ldy #>compress_txt
                jsr $ab1e
                
                lda #$00     ;vysledek bude unpacked
                sta $7fff
                
                lda #$00
                sta $fa
                lda #$80
                sta $fb      ;data se ukladaji od $8000
                
get_command     inc $d020
                dec $d020

                sec            ;test konce depakovaneho souboru
                lda $fa
                sbc #$f4
                lda $fb
                sbc #$bb
                bcs end_of_file

                jsr chrin
                ldx $90
                bne end_of_file
                
                cmp #$00
                bmi opakovani  ;1xxx opakovani 0xxx kopirovani
                
                and #%01111111
                sta $02
                beq data_error
                
copy_bytes      jsr chrin
                jsr store_byte
                dec $02
                bne copy_bytes
                jmp get_command
                
opakovani       and #%01111111
                sta $02
                beq data_error
                
                jsr chrin
opak_byte       jsr store_byte
                dec $02
                bne opak_byte                
                jmp get_command

;------------------------

data_error      jsr restore_system
                jsr file_err
                lda #<error_txt
                ldy #>error_txt
                jmp $ab1e

;--------------------------

end_of_file     lda #$01
                jsr close  ;zavre soubor
                jsr clall
                jmp start_view  ;zapne zobrazeni

store_byte      sei
                ldy #$34
                sty $01
                
                ldy #$00
                sta ($fa),y
                inc $fa
                bne not_high
                inc $fb
not_high        ldy #$37
                sty $01
                cli
                rts

;-------------------------------------------------------------------------
; routine READ_STATUS
; by DUNDERA Nov 14 1998 20:55:49 

read_status     lda     $b7
                pha
                lda     #$00
                sta     $b7
                
                lda     #$0f
                ldx     $ba
                ldy     #$0f
                jsr     setlfs
                jsr     open

                ldx     #$0f
                jsr     chkin    ;change input

                ldy #$00
read_all_bytes  jsr chrin
                sta status_buf,y
                iny
                cmp #$0d
                bne read_all_bytes
                
                lda #$00
                sta status_buf,y ;end of status
                
                lda status_buf
                sec
                sbc     #$30
                asl     a
                sta     tmp0
                asl
                asl
                clc
                adc     tmp0
                sta     tmp0
                
                lda status_buf+1
                sec
                sbc     #$30
                clc
                adc     tmp0
                sta     tmp0     ;error in HEX
                
             ;   lda     #$0f
             ;   jsr     close
             ;   jsr     clrchn  ;nezavirat, ubozi s DD
             
                pla
                sta     $b7
                lda     tmp0
                rts

;----------------------------------------------------
; routine LOAD data in memory
;-----------------------------------------------------
load_it         lda #$01
                jsr close
                jsr clall
                
                lda #$00   ;vypnout hlasky
                sta $9d
                
                lda #<load_txt  ;loading uncompressed picture
                ldy #>load_txt
                jsr $ab1e
                
                lda #$00
                ldx #$ff
                ldy #$7f   ;$7fff
                jsr load   ;load data into RAM
                
                bcc show_pic
                jsr restore_system
                sec
                rts        ;error during LOAD
                
show_pic        jmp start_view  ;ulozi na spravne misto a zapne IRQ

;-------------------------------------------------
file_err        lda #$01
                jsr close
                jsr clall
                sec        ;nastaveni priznaku chyby pro MANAGER
                rts

;--------------------------------------
; Show picture
;--------------------------------------
start_view      = *
                sei
                lda     #$34 ;nastavuje RAM
                sta     $01
                
                lda     #$00
                ldx     #$00
i118f           sta     $7400,x   ;nuluje hires colors
                sta     $7500,x
                sta     $7600,x
                sta     $7700,x
                sta     $7800,x
                sta     $7900,x
                sta     $7a00,x
                sta     $7b00,x 
                
                sta     $f400,x
                sta     $f500,x
                sta     $f600,x
                sta     $f700,x
                sta     $f800,x
                sta     $f900,x
                sta     $fa00,x
                sta     $fb00,x
                inx     
                bne     i118f


;----------------------------------------------------
;kopirovani bitmap na spravne misto                
                lda     #$00 ;
                sta     2
                lda     #$80 ;$8000
                sta     3
                
                lda     #$70 ;
                sta     4
                lda     #$40 ;$4070  ;uklada bitmapu 1
                sta     5
                
                lda     #$60 ;
                sta     6
                lda     #$89 ;$8960
                sta     7
                
                lda     #$70 ;
                sta     8
                lda     #$c0 ;$c070  ;uklada bitmapu 2
                sta     9
                
                ldx     #$19
i11e4           ldy     #$5f ;
i11e6           lda     (2),y   ;z $8000
                sta     (4),y   ;na $4070 (bm1)
                lda     (6),y   ;z $8960
                sta     (8),y   ;na $c070 (bm2)
                dey     
                bpl     i11e6
                
                lda     2
                clc     
                adc     #$60
                sta     2
                bcc     i11fc
                inc     3

i11fc           lda     4
                clc     
                adc     #$40
                sta     4
                sta     8
                bcc     i120b
                inc     5
                inc     9    ;hi addr pro ukladani bitmap

i120b           inc     5
                inc     9
                
                lda     6
                clc     
                adc     #$60 ; '`'
                sta     6
                bcc     i121a
                inc     7

i121a           dex     
                bne     i11e4

;--------------

                lda     #$c0 ;
                sta     2
                lda     #$92 ;$92c0 sprites 1
                sta     3
                
                lda     #$00 ;
                sta     4
                lda     #$60 ;$6000 ulozit
                sta     5
                
                lda     #$c0 ;
                sta     6
                lda     #$a6 ;$a6c0 sprites 2
                sta     7
                
                lda     #$00 ;
                sta     8
                lda     #$e0 ;$e000 ulozit
                sta     9
                
                ldx     #$14
                ldy     #$00
i1241           lda     (2),y
                sta     (4),y
                lda     (6),y
                sta     (8),y
                iny     
                bne     i1241
                inc     3
                inc     5
                inc     7
                inc     9
                dex     
                bne     i1241
                
                lda     #$c0 ; 
                sta     2
                lda     #$ba ;$bac0  (tady zacinaji hires color)
                sta     3
                
                lda     #$0e
                sta     4
                sta     6
                sta     8
                sta     $0a
                
                lda     #$74 ; $740e
                sta     5
                lda     #$78 ; $780e
                sta     7
                lda     #$f4 ; $f40e
                sta     9
                lda     #$f8 ; $f80e
                sta     $b
                
                ldx     #$19
i127b           ldy     #$b

i127d           lda     ($02),y ;vytvari kopie hires barev
                sta     ($04),y
                sta     ($06),y
                sta     ($08),y
                sta     ($0a),y
                dey     
                bpl     i127d
                
                lda     2
                clc     
                adc     #$0c
                sta     2
                bcc     i1295
                inc     3

i1295           lda     4
                clc     
                adc     #$28 ; dalsi radek
                sta     $04
                sta     $06
                sta     $08
                sta     $0a
                bcc     i12ac
                inc     $05
                inc     $07
                inc     $09
                inc     $0b

i12ac           dex     
                bne     i127b
                
                lda     #$36 
                sta     $01    ;Vypnuty BASIC
                
                ldx     #7
i12b5           lda     $bbec,x
                sta     $d027,x ;prepis barev sprajtu
                dex     
                bpl     i12b5

                lda     #$00    ;cerna barva pozadi
                sta     $d020
                
                ldx     #$ff

                stx     $d015   ;zapnout vsechny sprajty
                inx     
                stx     $d010   ;0 - MSB X
                stx     $d017   ;0 - zvetseni Y
                stx     $d01d   ;0 - zvetseni X
                inx     
                stx     $d01a   ;1 - IRQ mask register (IRQ od rastru)
                inx
                stx     $dd00   ;2 - videobanka
                
;--------------------------------nastaveni X souradnic pro sprajty
                
                lda     #$88  
                sta     $d000 ;x souradnice 0,4
                sta     $d008 ;
                
                clc     
                adc     #$18
                sta     $d002
                sta     $d00a
                
                adc     #$18
                sta     $d004
                sta     $d00c
                
                adc     #$18
                sta     $d006
                sta     $d00e

;----------------------------- Set Interrupt

                lda #$7f
                sta $dc0d     ; disable timer interrupts CIA #1
                sta $dd0d                       ;        CIA #2
                ldx #1
                stx $d01a     ; enable raster interrupt
                lda $dc0d     ; acknowledge CIA interrupts
                lsr $d019     ; and video interrupts
                
                lda     #<irq_disp  ;nastaveni zobrazovaciho IRQ
                sta     $0314
                lda     #>irq_disp
                sta     $0315
                
                lda     #$3b
                sta     $d011
                lda     #$c0    ; e0
                sta     $d018

                lda     #RASTER
                sta     $d012   ;nastaveni rastru
                sta scpu_normal
                cli     

;--------------------------------------
; Wait for SPACE
;--------------------------------------
i131a           = *
;                nop             ;test realneho programu
;                inc $0400
;                cmp ($02,x)
;                nop
;                nop
;                cmp ($02,x)
                lda #$10
                bit $dc01
                bne i131a
;--------------------------------------                

restore_system  sei
                sta scpu_turbo
                lda #$37
                sta $01
                
                lda irq_old
                sta $0314
                lda irq_old+1
                sta $0315
                
                lda #$9b
                sta $d011
                
                lda #$37
                sta $d012
                
                lda #$00
                sta $d015  ;vypnout sprajty
                
                lda #$08
                sta $d016
               
                lda vic_d018
                sta $d018
                
                lda #$0f
                sta $d019
                
                lda #$00
                sta $d01a
               
                lda vic_d020
                sta $d020
                
                lda vic_d021
                sta $d021
                
                lda #$81
                sta $dc0d   ;zaloha hodnot CIA
                
                lda cia_dd00
                sta $dd00
                
                lda messages
                sta $9d
                
                lda #$00
                sta $c6     ;nuluje buffer klavesnice
                
                clc                
                cli
                rts         ; END OF PROGRAMM
;---------------------------------------------------------------------
product_txt     .text $0d,"   SUPER HIRES INTERLACE VIEWER V1.1",$0d
                .text "  FOR IDE-HDD MANAGER BY DUNDERA 1998",$0d,0

file_txt        .text $0d,"INPUT FILENAME:",0

unknown_txt     .text $0d,"UNKNOWN COMPRESSION METHOD!!!",$0d,0

error_txt       .text $0d,"ERROR IN PACKED BYTES!!!",$0d,0

compress_txt    .text $0d,"RLC COMPRESSION DETECTED!",$0d,0

load_txt        .text $0d,"LOADING UNCOMPRESSED PICTURE...",$0d,0

invalid_txt     .text $0d,"INVALID IMAGE FORMAT!!!",$0d,0

man_sign        .byte 0  ;$80-basic, $00-MANAGER

vic_d018        .byte 0
vic_d020        .byte 0
vic_d021        .byte 0
cia_dd00        .byte 0
irq_old         .byte 0,0

tmp0            .byte 0
messages        .byte 0
                

filename        .text "0123456789abcdef"
status_buf      .text "0123456789abcdef01234567"         
 
